ByteArrayOutputStream (Apache Tomcat 9.0.118 API Documentation)
Description: declaration: package: org.apache.tomcat.util.http.fileupload, class: ByteArrayOutputStream

# Class ByteArrayOutputStream

java.lang.Object
java.io.OutputStream
org.apache.tomcat.util.http.fileupload.ByteArrayOutputStream

All Implemented Interfaces:
  `Closeable, Flushable, AutoCloseable`

public class ByteArrayOutputStream extends OutputStream
This class implements an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it.

The data can be retrieved using `toByteArray()` and `toString()`.

Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

This is an alternative implementation of the `ByteArrayOutputStream` class. The original implementation only allocates 32 bytes at the beginning. As this class is designed for heavy duty it starts at 1024 bytes. In contrast to the original it doesn't reallocate the whole memory block but allocates additional buffers. This way no buffers need to be garbage collected and the contents don't have to be copied to the new buffer. This class is designed to behave exactly like the original. The only exception is the deprecated toString(int) method that has been ignored.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ByteArrayOutputStream()`
  Creates a new byte array output stream.
  `ByteArrayOutputStream(int size)`
  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Closing a `ByteArrayOutputStream` has no effect.
  `byte[]`
  `toByteArray()`
  Gets the current contents of this byte stream as a byte array.
  `void`
  `write(byte[] b, int off, int len)`
  Write the bytes to byte array.
  `void`
  `write(int b)`
  Write a byte to byte array.
  `void`
  `writeTo(OutputStream out)`
  Writes the entire contents of this byte stream to the specified output stream.

  ### Methods inherited from class OutputStream

  `flush, nullOutputStream, write`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ByteArrayOutputStream

    public ByteArrayOutputStream()
    Creates a new byte array output stream. The buffer capacity is initially 1024 bytes, though its size increases if necessary.

  - ### ByteArrayOutputStream

    public ByteArrayOutputStream(int size)
    Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.
    Parameters:
      `size` - the initial size
    Throws:
      `IllegalArgumentException` - if size is negative

- ## Method Details

  - ### write

    public void write(byte[] b, int off, int len)
    Write the bytes to byte array.
    Overrides:
      `write` in class `OutputStream`
    Parameters:
      `b` - the bytes to write
      `off` - The start offset
      `len` - The number of bytes to write

  - ### write

    public void write(int b)
    Write a byte to byte array.
    Specified by:
      `write` in class `OutputStream`
    Parameters:
      `b` - the byte to write

  - ### close

    public void close() throws IOException
    Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `OutputStream`
    Throws:
      `IOException` - never (this method should not declare this exception but it has to now due to backwards compatibility)

  - ### writeTo

    public void writeTo(OutputStream out) throws IOException
    Writes the entire contents of this byte stream to the specified output stream.
    Parameters:
      `out` - the output stream to write to
    Throws:
      `IOException` - if an I/O error occurs, such as if the stream is closed
    See Also:
      - `ByteArrayOutputStream.writeTo(OutputStream)`

  - ### toByteArray

    public byte[] toByteArray()
    Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
    Returns:
      the current contents of this output stream, as a byte array
    See Also:
      - `ByteArrayOutputStream.toByteArray()`